searchData={"items":[{"type":"module","doc":"[oEmbed](https://oembed.com) plugin for [Req](https://hex.pm/packages/req).\n\nSupports [discovery](https://oembed.com/#section4) and 300+ [providers](https://github.com/BeaconCMS/req_embed/blob/main/priv/providers.json).","title":"ReqEmbed","ref":"ReqEmbed.html"},{"type":"module","doc":"```elixir\nMix.install([\n  {:req, \"~> 0.5\"},\n  {:req_embed, \"~> 0.1\"}\n])\n\nreq = Req.new() |> ReqEmbed.attach()\n\nReq.get!(req, url: \"https://www.youtube.com/watch?v=XfELJU1mRMg\").body\n#=>\n# %ReqEmbed.Video{\n#   type: \"video\",\n#   version: \"1.0\",\n#   title: \"Rick Astley - Never Gonna Give You Up (Official Music Video)\",\n#   author_name: \"Supirorguy508\",\n#   author_url: \"https://www.youtube.com/@supirorguy5086\",\n#   provider_name: \"YouTube\",\n#   provider_url: \"https://www.youtube.com/\",\n#   cache_age: nil,\n#   thumbnail_url: \"https://i.ytimg.com/vi/XfELJU1mRMg/hqdefault.jpg\",\n#   thumbnail_width: 480,\n#   thumbnail_height: 360,\n#   html: \"  \",\n#   width: 200,\n#   height: 113\n# }\n```\n\nWhen successful, the response body will contain either one of the following structs representing the oEmbed type:\n\n  - `ReqEmbed.Link`\n  - `ReqEmbed.Photo`\n  - `ReqEmbed.Rich`\n  - `ReqEmbed.Video`","title":"Usage - ReqEmbed","ref":"ReqEmbed.html#module-usage"},{"type":"function","doc":"Attach the oEmbed plugin into Req.","title":"ReqEmbed.attach/2","ref":"ReqEmbed.html#attach/2"},{"type":"function","doc":"* `:query` (`t:map/0`) - Defaults to `%{}`. The query parameters to be sent to the oEmbed endpoint,\n    like `:maxwidth`, `:maxheight`, and others supported by the provider.\n    The parameters `:url` and `:format` are managed by the plugin, you can't override them.\n    See section [2.2 Consumer Request](https://oembed.com/#section2) for more info.\n\n  * `:discover` (`t:boolean/0`) - Defaults to `true`. When enabled, it will first attempt to auto-discover\n    the oEmbed endpoint by looking for the link tag in the HTML response. If no link tag is found, it will\n    fallback to searching for a known provider endpoint. When disabled, it will skip the HTML parsing step\n    and only use the known provider endpoints.","title":"Options - ReqEmbed.attach/2","ref":"ReqEmbed.html#attach/2-options"},{"type":"function","doc":"iex> req = Req.new() |> ReqEmbed.attach()\n    iex> Req.get!(req, url: \"https://x.com/ThinkingElixir/status/1848702455313318251\").body\n    iex> %ReqEmbed.Rich{\n           type: \"rich\",\n           version: \"1.0\",\n           author_name: \"ThinkingElixir\",\n           author_url: \"https://twitter.com/ThinkingElixir\",\n           html: \"  News includes upcoming Elixir v1.18 ...\n           ...\n         }","title":"Examples - ReqEmbed.attach/2","ref":"ReqEmbed.html#attach/2-examples"},{"type":"module","doc":"Generic embed data type.\n\nThe simplest type that allows a provider to return any generic embed data without providing\neither the url or html parameters.\n\nSpec: [2.3.4.3. The link type](https://oembed.com/#section2)\n\nThese are the common fields that all oEmbed response types may include:\n\n* `type` (required) - The resource type. Valid values are: photo, video, link, rich\n* `version` (required) - The oEmbed version number. Must be \"1.0\"\n* `title` (optional) - A text title describing the resource\n* `author_name` (optional) - The name of the author/owner of the resource\n* `author_url` (optional) - A URL for the author/owner of the resource\n* `provider_name` (optional) - The name of the resource provider\n* `provider_url` (optional) - The url of the resource provider\n* `cache_age` (optional) - The suggested cache lifetime for this resource, in seconds\n* `thumbnail_url` (optional) - A URL to a thumbnail image representing the resource\n* `thumbnail_width` (optional) - The width of the optional thumbnail\n* `thumbnail_height` (optional) - The height of the optional thumbnail","title":"ReqEmbed.Link","ref":"ReqEmbed.Link.html"},{"type":"module","doc":"The photo type used to represent static photos.\n\nSpec: [2.3.4.1. The photo type](https://oembed.com/#section2)\n\nIncludes all base `ReqEmbed.Link` fields plus:\n\n* `url` (required) - The source URL of the image. Consumers should be able to insert this URL into an   element. Only HTTP and HTTPS URLs are valid\n* `width` (required) - The width in pixels of the image specified in the url parameter\n* `height` (required) - The height in pixels of the image specified in the url parameter","title":"ReqEmbed.Photo","ref":"ReqEmbed.Photo.html"},{"type":"module","doc":"The rich type used for rich HTML content that does not fall under one of the other categories.\n\nSpec: [2.3.4.4. The rick type](https://oembed.com/#section2)\n\nIncludes all base `ReqEmbed.Link` fields plus:\n\n* `html` (required) - The HTML required to display the resource. The HTML should have no padding or margins.\n  The markup should be valid XHTML 1.0 Basic\n* `width` (required) - The width in pixels required to display the HTML\n* `height` (required) - The height in pixels required to display the HTML","title":"ReqEmbed.Rich","ref":"ReqEmbed.Rich.html"},{"type":"module","doc":"The video type used to represent playable videos.\n\nSpec: [2.3.4.2. The video type](https://oembed.com/#section2)\n\nIncludes all base `ReqEmbed.Link` fields plus:\n\n* `html` (required) - The HTML required to embed a video player. The HTML should have no padding or margins\n* `width` (required) - The width in pixels required to display the HTML\n* `height` (required) - The height in pixels required to display the HTML","title":"ReqEmbed.Video","ref":"ReqEmbed.Video.html"},{"type":"extras","doc":"# Changelog","title":"Changelog","ref":"changelog.html"},{"type":"extras","doc":"","title":"0.1.2 (2025-03-13) - Changelog","ref":"changelog.html#0-1-2-2025-03-13"},{"type":"extras","doc":"* Removed `ReqEmbed.Content` in favor of `ReqEmbed.Link`","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"","title":"0.1.1 (2025-03-12) - Changelog","ref":"changelog.html#0-1-1-2025-03-12"},{"type":"extras","doc":"* Option `:discover` to turn discovery on/off","title":"Added - Changelog","ref":"changelog.html#added"},{"type":"extras","doc":"* Initial release","title":"0.1.0 (2025-03-12) - Changelog","ref":"changelog.html#0-1-0-2025-03-12"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}